Attribute VB_Name = "DatabaseAccess"
Option Explicit

'Workspace
Public wspLevy As Workspace

'Database
Public dbLevyOffice As Database




'Recordsets
Public rstSearchResults As Recordset
Public rstUsers As Recordset
Public rstCautionDepositDebits As Recordset
Public rstFeesTemplates As Recordset
Public rstLevyCredits As Recordset
Public rstLevyDebits As Recordset
Public rstRegisteredFees As Recordset
Public rstClasses As Recordset
Public rstStudents As Recordset
Public rstDeregisteredStudents As Recordset
Public rstCautionDepositCredits As Recordset

'Query Objects
Public qryQueryObject As QueryDef       'Utility query object
Public qryReports As QueryDef           'Query for generating reports
Public qryDirectSQL As QueryDef


Public Function FindStudentName(strStudentID As String) As String
    Dim strStudentName As String
    
    rstStudents.Index = "Student ID index"
    rstStudents.Seek "=", strStudentID
    If rstStudents.NoMatch Then
        strStudentName = "(Not Found)"
    Else
        strStudentName = rstStudents("Surname") & ", " & rstStudents("First names")
    End If
    
    FindStudentName = strStudentName
      
End Function

Public Function GetDatabasePath() As String
    On Local Error GoTo errorHandler
    
    Const errDBInit = 2 + vbObjectError + 512
    Dim strDBpath As String
    Dim strMsg As String
    Dim objFileSystem As New FileSystemObject
        
    strDBpath = GetSetting(regAppName, regSection, regKeyDBPath)
    
    If strDBpath = "" Then
        Err.Raise errDBInit, App.Title, "Registry entry corrupt."
    ElseIf strDBpath = strDBPathNotSet Then
        Err.Raise errDBInit, App.Title, "Database Path Not Set"
    ElseIf Not objFileSystem.FileExists(strDBpath) Then
        Err.Raise errDBInit, App.Title, "Database cannot be located."
    Else
        GetDatabasePath = strDBpath
    End If
    
Exit Function

errorHandler:
    MsgBox Err.Description & " Please contact technical support", vbCritical, "Critical System Error"
    End

End Function

Public Function InvalidStudentID(strStudentID As String, Optional reqSuppressMessage) As Boolean
    Dim strMsg As String
    
    If IsMissing(reqSuppressMessage) Then reqSuppressMessage = False
    
    'Checks if a student id is valid
    'Sets current record to that of the student if found
    
    If rstStudents.Index <> "Student ID Index" Then
        rstStudents.Index = "Student ID Index"
    End If
    
    rstStudents.Seek "=", strStudentID
    If rstStudents.NoMatch Then
        If Not reqSuppressMessage Then
            strMsg = "The entered student ID has not been registered with the system."
            MsgBox strMsg, vbExclamation, "Error in Student ID"
        End If
        InvalidStudentID = True
    Else
        InvalidStudentID = False
    End If
    
End Function

Public Function SelectsDataOnly(qryQuery As QueryDef)
    'Checks if a query will not modify the data
    'Update queries may bring about inconsistencies
    Select Case qryQuery.Type
        Case dbQSelect, dbQCrosstab, dbQSetOperation
            SelectsDataOnly = True
        Case Else
            SelectsDataOnly = False
    End Select
    
End Function

Public Function getSampleDBPath() As String
    getSampleDBPath = App.Path & "\setup\SampleDB.mdb"
End Function
