Attribute VB_Name = "DepositAccountRoutines"
Option Explicit

Public Function getDepositAccountBalance(strStudentID) As Currency
    Dim strSQL As String
    Dim rstDepositAccountBalance As Recordset
    
    
    If rstCautionDepositCredits.RecordCount = 0 And rstCautionDepositDebits.RecordCount = 0 Then
        getDepositAccountBalance = 0
    Else
        strSQL = "SELECT  IIF(isNull([Unrevised Credits]),0,[Unrevised Credits]) AS [Total Credits], " _
              & "        IIF(isNull([Unrevised Debits]),0,[Unrevised Debits]) AS [Total Debits], " _
              & "        ([Total Credits] - [Total Debits]) AS Balance " _
              & "FROM " _
              & "(  " _
              & "    SELECT  DISTINCTROW" _
              & "      (    SELECT  SUM([Caution Fee Account Credits].[Amount]) " _
              & "           FROM    [Caution Fee Account Credits] " _
              & "           WHERE   [Caution Fee Account Credits].[Student ID] = [Requested ID] " _
              & "      ) AS [Unrevised Credits], " _
              & "      (    SELECT   SUM([Caution Fee Account Debits].[Amount]) " _
              & "           FROM     [Caution Fee Account Debits] " _
              & "           WHERE    [Caution Fee Account Debits].[Student ID] = [Requested ID] " _
              & "      ) AS [Unrevised Debits] " _
              & "      FROM [Caution Fee Account Debits], [Caution Fee Account Credits] " _
              & "); "
            
        qryQueryObject.SQL = strSQL
        qryQueryObject.Parameters("Requested ID") = strStudentID
        
        Set rstDepositAccountBalance = qryQueryObject.OpenRecordset
        rstDepositAccountBalance.MoveFirst
        getDepositAccountBalance = rstDepositAccountBalance("Balance")
    End If
                
End Function

Public Function GetDepositStatementBodySQL() As String
    Dim strSQL As String
    
    strSQL = "SELECT  [Caution Fee Account Credits].[Transaction Date] AS [Transaction Date], " _
          & "        'Deposit' AS [Description], " _
          & "        [Caution Fee Account Credits].[Receipt Number] AS [Reference], " _
          & "        [Caution Fee Account Credits].Amount AS  [Amount] " _
          & "FROM    [Caution Fee Account Credits] " _
          & "WHERE   ((([Caution Fee Account Credits].[Student ID]) = [The Student])) " _
          & "        AND [Caution Fee Account Credits].[Transaction Date] >= [Start Date]" _
          & "        AND DateValue([Caution Fee Account Credits].[Transaction Date]) <= DateValue([End Date])" _
          & "UNION SELECT " _
          & "        [Caution Fee Account Debits].[Transaction Date], " _
          & "        [Caution Fee Account Debits].Reason, " _
          & "        [Caution Fee Account Debits].[Reference code], " _
          & "        ([Caution Fee Account Debits].Amount * -1) " _
          & "FROM    [Caution Fee Account Debits] " _
          & "WHERE   ((([Caution Fee Account Debits].[Student ID]) = [The Student])) " _
          & "        AND [Caution Fee Account Debits].[Transaction Date] >= [Start Date]" _
          & "        AND DateValue([Caution Fee Account Debits].[Transaction Date]) <= DateValue([End Date])" _
          & "ORDER BY [Transaction Date]; "
    
    GetDepositStatementBodySQL = strSQL
    
End Function

Public Function GetDepositOpeningBalance(strStudentID, dtmStartDate) As Currency
    Dim strSQL As String
    Dim rstOpeningBalance As Recordset
    
        strSQL = "SELECT  IIF(isNull([Unrevised Credits]),0,[Unrevised Credits]) AS [Total Credits], " _
              & "        IIF(isNull([Unrevised Debits]),0,[Unrevised Debits]) AS [Total Debits], " _
              & "        ([Total Credits] - [Total Debits]) AS Balance " _
              & "FROM " _
              & "(  " _
              & "    SELECT  DISTINCTROW" _
              & "      (    SELECT  SUM([Caution Fee Account Credits].[Amount]) " _
              & "           FROM    [Caution Fee Account Credits] " _
              & "           WHERE   [Caution Fee Account Credits].[Student ID] = [Requested ID] " _
              & "           AND     [Caution Fee Account Credits].[Transaction Date] < [Start Date] " _
              & "      ) AS [Unrevised Credits], " _
              & "      (    SELECT   SUM([Caution Fee Account Debits].[Amount]) " _
              & "           FROM     [Caution Fee Account Debits] " _
              & "           WHERE    [Caution Fee Account Debits].[Student ID] = [Requested ID] " _
              & "           AND      [Caution Fee Account Debits].[Transaction Date] < [Start Date] " _
              & "      ) AS [Unrevised Debits] " _
              & "      FROM [Caution Fee Account Debits], [Caution Fee Account Credits] " _
              & "); "
            
        qryQueryObject.SQL = strSQL
        qryQueryObject.Parameters("Requested ID") = strStudentID
        qryQueryObject.Parameters("Start Date") = dtmStartDate
        
        Set rstOpeningBalance = qryQueryObject.OpenRecordset
        rstOpeningBalance.MoveFirst
        GetDepositOpeningBalance = rstOpeningBalance("Balance")
    
End Function

Public Function GetDepositClosingBalance(strStudentID, dtmEndDate) As Currency
    Dim strSQL As String
    Dim rstClosingBalance As Recordset
    
        strSQL = "SELECT  IIF(isNull([Unrevised Credits]),0,[Unrevised Credits]) AS [Total Credits], " _
              & "        IIF(isNull([Unrevised Debits]),0,[Unrevised Debits]) AS [Total Debits], " _
              & "        ([Total Credits] - [Total Debits]) AS Balance " _
              & "FROM " _
              & "(  " _
              & "    SELECT  DISTINCTROW" _
              & "      (    SELECT  SUM([Caution Fee Account Credits].[Amount]) " _
              & "           FROM    [Caution Fee Account Credits] " _
              & "           WHERE   [Caution Fee Account Credits].[Student ID] = [Requested ID] " _
              & "           AND     DateValue([Caution Fee Account Credits].[Transaction Date]) <= DateValue([End Date]) " _
              & "      ) AS [Unrevised Credits], " _
              & "      (    SELECT   SUM([Caution Fee Account Debits].[Amount]) " _
              & "           FROM     [Caution Fee Account Debits] " _
              & "           WHERE    [Caution Fee Account Debits].[Student ID] = [Requested ID] " _
              & "           AND      DateValue([Caution Fee Account Debits].[Transaction Date]) <= DateValue([End Date]) " _
              & "      ) AS [Unrevised Debits] " _
              & "      FROM [Caution Fee Account Debits], [Caution Fee Account Credits] " _
              & "); "
            
        qryQueryObject.SQL = strSQL
        qryQueryObject.Parameters("Requested ID") = strStudentID
        qryQueryObject.Parameters("End Date") = dtmEndDate
        
        Set rstClosingBalance = qryQueryObject.OpenRecordset
        rstClosingBalance.MoveFirst
        GetDepositClosingBalance = rstClosingBalance("Balance")
    
End Function

Public Function GetDepositStatementBody(ByVal strStudentID As String, ByVal dtmStartDate As Date, ByVal dtmEndDate As Date) As Recordset
    Dim strSQL As String
    strSQL = GetDepositStatementBodySQL
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("The Student") = strStudentID
    qryQueryObject.Parameters("Start Date") = dtmStartDate
    qryQueryObject.Parameters("End Date") = dtmEndDate
    Set GetDepositStatementBody = qryQueryObject.OpenRecordset
                
End Function

Public Sub PrintDepositStatement(strStudentID As String, strStudentName As String, _
                            strStudentClass As String, dtmStartDate As Date, _
                            dtmEndDate As Date, curOpeningBalance As Currency, _
                            curMinBalance As Currency, curCurrentBalance As Currency, _
                            curClosingBalance As Currency, rstStatement As Recordset)
        
    Dim lngRowCounter As Long
    
        
    'Print header
    Printer.CurrentY = 3
    PrintHeader ("Mount Pleasant High School")
    PrintHeader ("Caution Deposit Statement of Account")
    PrintBlankLines (1)
    'print student details
    Call SendDepositStatementHeader(strStudentID, strStudentName, strStudentClass, dtmStartDate, _
                            dtmEndDate, curOpeningBalance, curMinBalance, curCurrentBalance, _
                            curClosingBalance)
    
    'Printing header of column names
    PrintBlankLines (1)
    PrintDepositStatementColumnTitleRow
    PrintBlankLines (1)
    
    
    'Print opening balance
    Call PrintDepositBalance(dtmStartDate, "Opening Balance", curOpeningBalance)
        
    'Print body if present
    If rstStatement.RecordCount <> 0 Then
        rstStatement.MoveFirst
        For lngRowCounter = 1 To rstStatement.RecordCount
            'If current line 3 rows from end of page then request new page and print a header
            If Printer.CurrentY = Printer.ScaleHeight - 3 Then
                Printer.NewPage
                Printer.CurrentY = 2
                PrintDepositStatementColumnTitleRow
                PrintBlankLines (1)
            End If
            
            'Transaction date
            Printer.CurrentX = getDepositCurrentX(0)
            Printer.Print Format(rstStatement("Transaction Date"), "dd mmm yyyy");
            
            'Description
            Printer.CurrentX = getDepositCurrentX(1)
            Printer.Print rstStatement("Description");
            
            'Ref Code
            Printer.CurrentX = getDepositCurrentX(2)
            Printer.Print rstStatement("Reference");
            
            'Amount
            Printer.CurrentX = getDepositCurrentX(3)
            
            Printer.Print CurrencyFormat(rstStatement("Amount"))
            rstStatement.MoveNext
        Next
    End If
        
    Call PrintDepositBalance(dtmEndDate, "Closing Balance", curClosingBalance)
    Printer.NewPage
    
            
End Sub

Private Sub PrintDepositStatementColumnTitleRow()
    Dim lngColCounter As Long
    
    
    Printer.CurrentX = getDepositCurrentX(0)
    Printer.Print "Date";
    
    Printer.CurrentX = getDepositCurrentX(1)
    Printer.Print "Details";
    
    Printer.CurrentX = getDepositCurrentX(2)
    Printer.Print "Reference";
    
    Printer.CurrentX = getDepositCurrentX(3)
    Printer.Print "   Amount"
    PrintBlankLines (1)
    Printer.Line (0, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
    
    
End Sub

Private Function getDepositCurrentX(Column As Long) As Long
    Dim lngReturnValue As Long
    
    Select Case Column
        Case 0
            lngReturnValue = 3
        Case 1
            lngReturnValue = 20
        Case 2
            lngReturnValue = 52
        Case 3
            lngReturnValue = 72
    End Select

    getDepositCurrentX = lngReturnValue
    
End Function

Private Sub SendDepositStatementHeader(strStudentID As String, strStudentName As String, _
                                strStudentClass As String, dtmStartDate As Date, _
                                dtmEndDate As Date, curOpeningBalance As Currency, _
                                curMinBalance As Currency, curCurrentBalance As Currency, _
                                curClosingBalance As Currency)
    
    Dim BalanceDescription As String
    Dim StatementPeriod As String
    Dim FormatedCurrency As String
    
    Call PrintStudentDetails("Student ID", strStudentID)
    Call PrintStudentDetails("Name", strStudentName)
    Call PrintStudentDetails("Class", strStudentClass)
    
    'Period actually printed
    StatementPeriod = Format(dtmStartDate, "d mmmm yyyy") & " - " & Format(dtmEndDate, "d mmmm yyyy")
    Call PrintStudentDetails("Statement Period", StatementPeriod)
    
    'Print when statement was generated
    Call PrintStudentDetails("Generated", Format(Now, "dddd d mmmm yyyy hh:mm"))
    
    'Balance on account NOW
    Call PrintStudentDetails("Current Balance", CurrencyFormat(curCurrentBalance))
    
    'Minimum Balance on account as to class records
    Call PrintStudentDetails("Minimum Balance", CurrencyFormat(curMinBalance))
    
    'State whether there is CURRENTLY as shortfall or not
    If curCurrentBalance <= curMinBalance Then
        BalanceDescription = "Current Shortfall" & Tabs(1)
    Else
        BalanceDescription = "Current Excess" & Tabs(1)
    End If
    FormatedCurrency = CurrencyFormat(curMinBalance - curCurrentBalance, , moneyExcludeType)
    Call PrintStudentDetails(BalanceDescription, FormatedCurrency)
    
End Sub




Private Sub PrintDepositBalance(EntryDate As Date, Description As String, _
                                Amount As Currency)
    
    Printer.CurrentX = getDepositCurrentX(0)
    Printer.Print Format(EntryDate, "dd mmm yyyy");
    
    Printer.CurrentX = getDepositCurrentX(1)
    Printer.Print Description;
    
    Printer.CurrentX = getDepositCurrentX(3)
    Printer.Print CurrencyFormat(Amount)
    
    
End Sub

Public Function getClassMinBalance(reqClass As String) As Currency
    Dim strMsg As String
    
    rstClasses.Index = "Class Index"
    rstClasses.Seek "=", reqClass
    
    If rstClasses.NoMatch Then
        strMsg = "Cannot determine min balance. Please contact technical support"
        MsgBox strMsg, vbCritical, "System Error"
    Else
        getClassMinBalance = rstClasses("Minimum Balance")
    End If
    
End Function
